//29
#ifndef WIN_H
#define WIN_H

#include <QMainWindow>
#include <QObject>
#include <QVector>
#include <QStringList>
#include "ui_pathshow.h"

class QAction;
class QTextStream;

class Map : QObject {
	Q_OBJECT;
	private:
		int startX;
		int startY;
		inline void insertSpeed( int x, int y );
	public:
		enum Field {
			Road,
			GoodRoad,
			Start,
			End,
			Out,
			Mark
		};
		struct Pos {
			Field field;
		};
		int width;
		int height;
		Map( QTextStream *s );
		QVector< QVector< Pos > > pos;
		void compute();
		QStringList list;
};

class Draw : public QWidget {
	private:
		Map *map;
	protected:
		void paintEvent( QPaintEvent *e );
	public:
		Draw();
		void setMap( Map *m );
};

class Win : public QMainWindow {
	Q_OBJECT;
	private:
		QAction *open;
		QAction *compute;
		Map *map;
		Draw *d;
	public:
		Win();
		~ Win();
	private slots:
		inline void load();
		inline void comp();
};

class PathShow : public QDialog, private Ui::PathShow {
	Q_OBJECT;
	private:
		QStringList listS;
	public:
		PathShow( const QStringList &l ) : listS( l ) { setupUi( this ); list->addItems( l ); setAttribute( Qt::WA_DeleteOnClose ); }
	private slots:
		inline void on_saveButt_clicked();
};

#endif
